Bug 1022407 - Review Request: yumdaemon - DBus API for yum
Review Request: yumdaemon - DBus API for yum
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jerry James
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-23 04:45 EDT by Tim Lauridsen
Modified: 2013-11-10 01:22 EST (History)
6 users (show)

See Also:
Fixed In Version: yumdaemon-0.9.2-5.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-02 00:57:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
loganjerry: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Tim Lauridsen 2013-10-23 04:45:41 EDT
Spec URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon.spec
SRPM URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon-0.9.2-1.fc19.src.rpm
Description: A DBus API for performing package actions using yum
Fedora Account System Username: timlau
Comment 1 Ralf Corsepius 2013-10-23 05:41:27 EDT
Just some remarks based on very brief checks on F19 (It's unlikely I'll be formally reviewing this, because my knowledge on python is fairly limited):

MUSTFIX:
*
warning: File listed twice: /usr/share/dbus-1/services/org.baseurl.YumSession.service
warning: File listed twice: /usr/share/dbus-1/system-services/org.baseurl.YumSystem.service
warning: File listed twice: /usr/share/polkit-1/actions
warning: File listed twice: /usr/share/polkit-1/actions/org.baseurl.YumSystem.policy

* Unowned directories:
/usr/lib/python3.3/site-packages/yumdaemon/
/usr/lib/python2.7/site-packages/yumdaemon/


SHOULD:
* rm -rf $RPM_BUILD_ROOT in %install
You don't seem to support EPEL, so this line doesn't make much sense.

* %files  contains
%{_datadir}/*
This is too general at least for my taste


UPSTREAM CONSIDER: 
The package does not honor/receive any configuration input parameters (e.g. installation paths) - I'd recommend upstream to change this.
Comment 2 Mosaab Alzoubi 2013-10-23 05:58:27 EDT
Ok Tim , Good Job :)

There is mixed-use-of-spaces-and-tabs
Comment 3 Tim Lauridsen 2013-10-23 07:33:55 EDT
Spec URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon.spec
SRPM URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon-0.9.2-2.fc19.src.rpm

This should fix.
- mixed-use-of-spaces-and-tabs
- Unowned directories
- rm -rf $RPM_BUILD_ROOT in %install
- warning: File listed twice

@Ralf.
I am not sure what you mean with
The package does not honor/receive any configuration input parameters
what should be differnt ??
Comment 4 Björn "besser82" Esser 2013-10-23 07:47:33 EDT
(In reply to Tim Lauridsen from comment #3)
> @Ralf.
> I am not sure what you mean with
> The package does not honor/receive any configuration input parameters
> what should be differnt ??

Since there is no action during %build, I assume Ralf is talking about the problem of hardcoded paths and such inside the sources, e.g. hardcoded '/etc', '/usr/share/' instead of some configure-script does expand them from given values (--sysconfdir=%{_sysconfdir}) during %build.
Comment 5 Tim Lauridsen 2013-10-23 08:54:12 EDT
OK, got it

I will change /etc -> $(SYDCONFDIR) & /usr/share -> $(DATADIR) in Makefile

and call 

make install DESTDIR=$RPM_BUILD_ROOT DATADIR=%{_datadir} SYSCONFDIR=%{_sysconfdir}

in spec
Comment 6 Tim Lauridsen 2013-10-23 09:07:02 EDT
Spec URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon.spec
SRPM URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon-0.9.2-2.fc19.src.rpm

- fixes dont use hardcoded paths in Makefile
Comment 8 Jerry James 2013-10-23 11:58:09 EDT
I will take this review.
Comment 9 Jerry James 2013-10-23 13:26:26 EDT
Just a few minor issues, in no particular order:
1) The package owns %{_datadir}/polkit-1/actions, but that directory is already
   owned by polkit, which this package requires.  This package should only own
   the contents of that directory, not the directory itself.
2) The files in %{_sysconfdir}/dbus-1/system.d are marked %config, but not
   %config(noreplace).  Is there a reason for that?
3) Please check on the script-without-shebang error reported by rpmlint below.
4) The first line of %install:

   rm -rf $RPM_BUILD_ROOT

   is not needed in any supported Fedora version.  Comment 3 indicates this was
   already removed.  It must have come back to life. :-)

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 11 files have unknown
     license. Detailed output of licensecheck in
     /home/jamesjer/1022407-yumdaemon/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/share/polkit-1/actions(polkit, systemd)
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: %config files are marked noreplace or the reason is justified.
     Note: No (noreplace) in %config /etc/dbus-1/system.d/*
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 71680 bytes in 10 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: yumdaemon-0.9.2-3.fc21.noarch.rpm
          python3-yumdaemon-0.9.2-3.fc21.noarch.rpm
          python-yumdaemon-0.9.2-3.fc21.noarch.rpm
          yumdaemon-0.9.2-3.fc21.src.rpm
yumdaemon.noarch: W: spelling-error Summary(en_US) Dbus -> Bus, D bus, Dubs
yumdaemon.noarch: W: spelling-error %description -l en_US Dbus -> Bus, D bus, Dubs
yumdaemon.noarch: W: conffile-without-noreplace-flag /etc/dbus-1/system.d/org.baseurl.YumSystem.conf
python3-yumdaemon.noarch: W: spelling-error Summary(en_US) api -> pi, ape, apt
python3-yumdaemon.noarch: W: spelling-error %description -l en_US api -> pi, ape, apt
python3-yumdaemon.noarch: W: no-documentation
python3-yumdaemon.noarch: E: script-without-shebang /usr/lib/python3.3/site-packages/yumdaemon/__init__.py
python-yumdaemon.noarch: W: spelling-error Summary(en_US) api -> pi, ape, apt
python-yumdaemon.noarch: W: spelling-error %description -l en_US api -> pi, ape, apt
python-yumdaemon.noarch: W: no-documentation
python-yumdaemon.noarch: E: script-without-shebang /usr/lib/python2.7/site-packages/yumdaemon/__init__.py
yumdaemon.src: W: spelling-error Summary(en_US) Dbus -> Bus, D bus, Dubs
yumdaemon.src: W: spelling-error %description -l en_US Dbus -> Bus, D bus, Dubs
4 packages and 0 specfiles checked; 2 errors, 11 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python3-yumdaemon python-yumdaemon yumdaemon
python3-yumdaemon.noarch: W: spelling-error Summary(en_US) api -> pi, ape, apt
python3-yumdaemon.noarch: W: spelling-error %description -l en_US api -> pi, ape, apt
python3-yumdaemon.noarch: W: no-documentation
python3-yumdaemon.noarch: E: script-without-shebang /usr/lib/python3.3/site-packages/yumdaemon/__init__.py
python-yumdaemon.noarch: W: spelling-error Summary(en_US) api -> pi, ape, apt
python-yumdaemon.noarch: W: spelling-error %description -l en_US api -> pi, ape, apt
python-yumdaemon.noarch: W: no-documentation
python-yumdaemon.noarch: E: script-without-shebang /usr/lib/python2.7/site-packages/yumdaemon/__init__.py
yumdaemon.noarch: W: spelling-error Summary(en_US) Dbus -> Bus, D bus, Dubs
yumdaemon.noarch: W: spelling-error %description -l en_US Dbus -> Bus, D bus, Dubs
yumdaemon.noarch: W: conffile-without-noreplace-flag /etc/dbus-1/system.d/org.baseurl.YumSystem.conf
3 packages and 0 specfiles checked; 2 errors, 9 warnings.
# echo 'rpmlint-done:'



Requires
--------
python3-yumdaemon (rpmlib, GLIBC filtered):
    python(abi)
    python3-gobject
    yumdaemon

python-yumdaemon (rpmlib, GLIBC filtered):
    pygobject3
    python(abi)
    yumdaemon

yumdaemon (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/python
    config(yumdaemon)
    dbus-python
    policycoreutils-python
    polkit
    yum



Provides
--------
python3-yumdaemon:
    python3-yumdaemon

python-yumdaemon:
    python-yumdaemon

yumdaemon:
    config(yumdaemon)
    yumdaemon



Source checksums
----------------
https://fedorahosted.org/releases/y/u/yumex/yumdaemon-0.9.2.tar.gz :
  CHECKSUM(SHA256) this package     : efc6e3aec324a25de76ddbd82419d0e0efdd0ac73e45b24b8722aa4f34ddcbc6
  CHECKSUM(SHA256) upstream package : efc6e3aec324a25de76ddbd82419d0e0efdd0ac73e45b24b8722aa4f34ddcbc6


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1022407 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api
Disabled plugins: Java, C/C++, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 10 Tim Lauridsen 2013-10-23 13:51:04 EDT
Spec URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon.spec
SRPM URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon-0.9.2-4.fc19.src.rpm

fixes 1) % 4)

2)
the dbus system conf files, should not edited by the users and shall be overwritten by the packages, so no noreplace here.

3)
There is no shebang because same python module source is used for both python2 & python3 package
Comment 11 Jerry James 2013-10-23 16:03:12 EDT
(In reply to Tim Lauridsen from comment #10)
> 2)
> the dbus system conf files, should not edited by the users and shall be
> overwritten by the packages, so no noreplace here.

If it should not be edited by users, then it shouldn't be %config either, though.  That essentially means, "go ahead and edit this file, but the next time you upgrade its package, we're going to blow away all of your changes."

> 3)
> There is no shebang because same python module source is used for both
> python2 & python3 package

Sorry, I didn't make my meaning clear.  The file is executable, but has no shebang.  If it should not be executed directly, then it should be 0644, not 0755.
Comment 12 Tim Lauridsen 2013-10-24 00:39:20 EDT
Spec URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon.spec
SRPM URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon-0.9.2-5.fc19.src.rpm

- changed permissions to 644 on python2 & python3 client api
- removed %config from DBus system service config & addded comment
Comment 13 Christopher Meng 2013-10-24 00:42:13 EDT
IMO you should leave a blank line per entry of changelog.
Comment 14 Tim Lauridsen 2013-10-24 00:57:19 EDT
Spec URL: http://timlau.fedorapeople.org/files/yumdaemon/yumdaemon.spec

Add blank lines in changelog
Comment 15 Jerry James 2013-10-24 10:58:13 EDT
Everything looks good now.  APPROVED.
Comment 16 Tim Lauridsen 2013-10-24 11:58:24 EDT
New Package SCM Request
=======================
Package Name: yumdaemon
Short Description: DBus API for yum
Owners: timlau
Branches: f19 f20
InitialCC:
Comment 17 Gwyn Ciesla 2013-10-24 12:38:57 EDT
Git done (by process-git-requests).
Comment 18 Tim Lauridsen 2013-10-24 12:47:15 EDT
Thanks for review, Jerry !
Comment 19 Fedora Update System 2013-10-24 13:17:14 EDT
yumdaemon-0.9.2-5.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/yumdaemon-0.9.2-5.fc19
Comment 20 Fedora Update System 2013-10-24 13:17:24 EDT
yumdaemon-0.9.2-5.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/yumdaemon-0.9.2-5.fc20
Comment 21 Fedora Update System 2013-10-24 21:53:54 EDT
yumdaemon-0.9.2-5.fc19 has been pushed to the Fedora 19 testing repository.
Comment 22 Fedora Update System 2013-11-02 00:57:51 EDT
yumdaemon-0.9.2-5.fc19 has been pushed to the Fedora 19 stable repository.
Comment 23 Fedora Update System 2013-11-10 01:22:32 EST
yumdaemon-0.9.2-5.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.